/*
  Adnan Khan
  Complete project details at https://www.instructables.com/editInstructable/edit/EDE00WUKAFCY9IN
  
  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files.
  
  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.
*/

//Puppet controller(Server) 

#define MUX_A D7
#define MUX_B D6
#define MUX_C D5
#define ANALOG_INPUT A0


// Import required libraries
#include <ESP8266WiFi.h>
#include "ESPAsyncWebServer.h"
int J1,J2,J3;




// Set your access point network credentials
const char* ssid = "ESP8266-Access-Point";
const char* password = "123456789";


// Create AsyncWebServer object on port 80
AsyncWebServer server(80);

String joint1() {return String(J1);}
String joint2() {return String(J2);}
String joint3() {return String(J3);}

void setup()
{ 
  // Serial port for debugging purposes
  Serial.begin(115200);
  Serial.println();
  
  // Setting the ESP as an access point
  Serial.print("Setting AP (Access Point)…");
  // Remove the password parameter, if you want the AP (Access Point) to be open
  WiFi.softAP(ssid, password);

  IPAddress IP = WiFi.softAPIP();
  Serial.print("AP IP address: ");
  Serial.println(IP);

  server.on("/joint1", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/plain", joint1().c_str());
  });
  server.on("/joint2", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/plain", joint2().c_str());
  });
  server.on("/joint3", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/plain", joint3().c_str());
  });
 
// Start server
  server.begin();

  //Deifne output pins for Mux
pinMode(MUX_A, OUTPUT);
pinMode(MUX_B, OUTPUT);     
pinMode(MUX_C, OUTPUT);
}

void loop()
{
  
  changeMux(LOW, LOW, LOW);
  J1=map(analogRead(ANALOG_INPUT), 0, 1023, 0, 300); //Value of the sensor connected Option 0 pin of Mux
  delay(100);
  changeMux(LOW, LOW, HIGH);
  J2=map(analogRead(ANALOG_INPUT), 0, 1023, 0, 300); //Value of the sensor connected Option 1 pin of Mux
  delay(100); 
  changeMux(LOW, HIGH, LOW);
  J3=map(analogRead(ANALOG_INPUT), 0, 1023, 0, 300); //Value of the sensor connected Option 2 pin of Mux
  delay(100);

}
 
 void changeMux(int c, int b, int a) 
{
  digitalWrite(MUX_A, a);
  digitalWrite(MUX_B, b);
  digitalWrite(MUX_C, c);
}
